<?php

namespace App\Service;

use Symfony\Component\Filesystem\Filesystem;
use Symfony\Contracts\HttpClient\HttpClientInterface;
use Symfony\Component\HttpFoundation\File\File;

class PdfService
{
    /**
     * @var HttpClientInterface
     */
    private $client;

    /**
     * @var string
     */
    private $projectDir;

    /**
     * @var Filesystem
     */
    private $filesystem;

    public function __construct(HttpClientInterface $pdfModuleApiClient, string $projectDir, Filesystem $filesystem)
    {
        $this->client = $pdfModuleApiClient;
        $this->projectDir = $projectDir;
        $this->filesystem = $filesystem;
    }

    public function generateCreditNote(string $storagePath, array $fields): string
    {
        return $this->generateFile('credit-note', $storagePath, $fields);
    }

    public function generateInvoice(string $storagePath, array $fields): string
    {
        return $this->generateFile('invoice', $storagePath, $fields);
    }

    public function generateInvoicePaymentReceived(string $storagePath, array $fields): string
    {
        return $this->generateFile('invoice-payment-received', $storagePath, $fields);
    }

    public function generateSettlementInvoice(string $storagePath, array $fields): string
    {
        return $this->generateFile('invoice-settlement', $storagePath, $fields);
    }

    public function getTermsAndConditionsFile(): File
    {
        // TODO change this to file generated by PDF module
        return new File(sprintf('%s/templates/SPPD-VOP-eshop.pdf', $this->projectDir));
    }

    /**
     * @param string $templateKey PDF template key
     * @param string $storagePath Storage path relative to project directory
     * @param array $fields Fields for generated file
     * @return string File path relative to project directory
     */
    private function generateFile(string $templateKey, string $storagePath, array $fields)
    {
        // prepare storage directory
        $storageDir = $this->projectDir.$storagePath;
        $this->filesystem->mkdir($storageDir);

        // request to generate PDF
        $response = $this->client->request('POST', sprintf('generate/%s', $templateKey), [
            'json' => [
                'fields' => $fields,
            ],
        ]);

        $fileName = $this->extractFilenameFromHeaders($response->getHeaders(), sprintf('%s.pdf', $templateKey));

        // download to temporary file
        $tmpFile = $this->filesystem->tempnam($storageDir, 'generate_');
        $fileHandler = fopen($tmpFile, 'w');
        foreach ($this->client->stream($response) as $chunk) {
            fwrite($fileHandler, $chunk->getContent());
        }
        fclose($fileHandler);

        // rename temporary file to final filename
        $filePath = $storageDir.'/'.$fileName;
        $this->filesystem->rename($tmpFile, $filePath, true);

        // return relative path
        return rtrim($this->filesystem->makePathRelative($filePath, $this->projectDir), '/');
    }

    private function extractFilenameFromHeaders(array $headers, string $default): string
    {
        if (isset($headers['content-disposition'][0])
            && preg_match('/filename=([^;=\n]*)/', $headers['content-disposition'][0], $matches)
        ) {
            return trim($matches[1], '\'"');
        }

        return $default;
    }
}
